/************************************************************************
	Box.java

    A class used to illustrate inheritance--
    For this example, a box is six-sided figure where each face is a
    square or rectangle
************************************************************************/

public class Box
{

	/***********************************************************************************
	  Instance variables.  The protected modifier is used to control access to the items.
	***********************************************************************************/

	protected float height;
	protected float length;
	protected float width;

	/***********************************************************************************
	  Constructors

	  Default constructor sets all 3 dimensions to 1.0
	***********************************************************************************/

    public Box ()
    {   height = 1.0f;
    	length = 1.0f;
    	width = 1.0f;
	}

	public Box (float height, float length, float width)
	{	if (height > 0.0f)
			this.height = height;
		else
			height = 1.0f;

		if (length > 0.0f)
			this.length = length;
		else
			length = 1.0f;

		if (width > 0.0f)
			this.width = width;
		else
			width = 1.0f;
	}


	/***********************************************************************************
	    Accessors
	***********************************************************************************/

	public float getHeight()
		{ return height; }

	public float getLength()
		{ return length; }

	public float getWidth()
		{ return width; }

	/***********************************************************************************
	    Mutators
	***********************************************************************************/
	public void setHeight(float height)
	{
		if (height > 0) this.height = height; }

	public void setLength(float length)
	{
		if (length > 0) this.length = length; }

	public void setWidth(float width)
	{
		if (width > 0) this.width = width; }

	/***********************************************************************************
	    Additional Methods
	***********************************************************************************/

	public float getVolume()
	{	return (height * length * width);  }

 	public String toString()
	{	return ("Height: " + height + "\nLength: " + length + "\nHeight: " + width + "\n");   }

}

