//************************************************************************
//  BoxDriver.java
//
//	This is a simple Java application (driver) to illustrate inheritance
//
//  The following classes are used:
//		Box
//		StorageBox (child of Box)- represents any type of storage box
//		DepositBox (child of Box)- represents a bank deposit box
//************************************************************************


public class BoxDriver
{
	public static void main (String[] args)
	{
		float boxHeight = 10.0f, boxLength = 10.0f, boxWidth = 10.0f;
		float pizzaBoxHeight = 12.0f, pizzaBoxLength = 12.0f, pizzaBoxWidth = 2.5f;

		//***********************************************************************************
		//  Instantiations from classes in the Box hierarchy
		//***********************************************************************************
		Box simpleBox = new Box(boxHeight, boxLength, boxWidth);
		StorageBox  pizzaBox = new StorageBox (pizzaBoxHeight, pizzaBoxLength, pizzaBoxWidth, "Cardboard", "Pepperoni Pizza");
		StorageBox  jewelryBox = new StorageBox (5.5f, 12.25f, 5.75f, "Cherry Wood", "Rings, Necklaces, Earrings, Bracelets");
		DepositBox companyDepositBox = new DepositBox(4.0f, 24.0f, 3.5f, "1025B", 10);
		DepositBox personalDepositBox = new DepositBox();

		//***********************************************************************************
		//  Display of class data from classes in the Box hierarchy
		//***********************************************************************************
		System.out.println("***********************Instantiation Data ************************************");
		System.out.println("simpleBox: \n" + simpleBox + "\n");
		System.out.println("pizzaBox: \n" + pizzaBox  + "\n");
		System.out.println("jewelryBox: \n" + jewelryBox  + "\n");
		System.out.println("companyDepositBox: \n" + companyDepositBox  + "\n");
		System.out.println("personalDepositBox: \n" + personalDepositBox  + "\n");



	}

	}
