//************************************************************************
//	DepositBox.java
//
//  A class used to illustrate inheritance
//  This class extend Box.  For this example, a standard deposit box
//  has a size of 4x24x10.  These values will be used as defaults.
//************************************************************************

public class DepositBox extends Box
{
	/***********************************************************************************
	    Instance variables
	***********************************************************************************/

	private String boxNumber;
	private int contentCount;

	/***********************************************************************************
	    Constructors
	    Deafult constructor sets size of deposit box to 4x24x10
	***********************************************************************************/

	public DepositBox ()
	    {   super(4.0f, 24.0f, 10.0f);
	    	boxNumber = "Not available";
	    	contentCount = 0;
		}

	public DepositBox (float height, float length, float width, String boxNumber, int contentCount)
		{	super(height, length, width);
			this.boxNumber = boxNumber;
			if (contentCount >= 0)
				this.contentCount = contentCount;
			else
				contentCount = 0;
		}

	/***********************************************************************************
	    Accessors for child class
	***********************************************************************************/

	public String getBoxNumber()
	{ return boxNumber; 	}

	public int getContentCount()
	{ return contentCount; 	}

	/***********************************************************************************
	    Mutators for child class
	***********************************************************************************/
	public void addContents(int newItemsToAdd)
	{ 	if (newItemsToAdd > 0)
				contentCount += newItemsToAdd;
	}

	public void removeContents(int newItemsToRemove)
	{ 	if (newItemsToRemove > 0 && newItemsToRemove <= contentCount)
				contentCount -= newItemsToRemove;
	}
	/***********************************************************************************
	    Additional Methods
	***********************************************************************************/

 	public String toString()
	{
		return super.toString() + "Deposit Box Number: " + boxNumber + "\nNumber of Items in the Deposit Box: " + contentCount + "\n";
	}
}

